#include <stdio.h>
#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ld long double
#define pb push_back
#define mp make_pair
#define pii pair<int, int>
#define pll pair<ll, ll>
#define pdd pair<ld, ld>
#define all(x) (x).begin(), (x).end()
#define fi first
#define se second

const int kMaxN = 2000;
const int kInf = (1LL << 31) - 1;
const int kMaxVal = 1e6;

int v[kMaxN + 5];
int dp[kMaxN + 5][kMaxN + 5];

int main() {
  ifstream cin("antivirus.in");
  ofstream cout("antivirus.out");

  int t;
  cin >> t;

  for (; t; t--) {
    int n, m;
    cin >> n >> m;
    assert(n <= kMaxN);

    for (int i = 1; i <= n; i++) {
      cin >> v[i];
      assert(v[i] <= kMaxVal);
      m -= (v[i] == 0);
    }

    for (int i = 0; i < kMaxN; i++) {
      for (int j = 0; j < kMaxN; j++) {
        dp[i][j] = kInf;
      }
    }

    for (int i = 0; i <= n; i++) {
      dp[i][0] = 0;
    }

    for (int i = 1; i <= n; i++) {
      for (int j = m; j >= 1; j--) {
        dp[i][j] = dp[i - 1][j];
      }

      int speciale = 0;
      bool have_special = 0;
      int cost = 0;
      for (int k = i; k >= 1; k--) {
        speciale += (v[k] != 0);
        have_special |= (v[k] == 0);
        cost += v[k];
        if (!have_special) {
          continue;
        }
        for (int j = m; j >= 1 && j >= speciale; j--) {
          if (dp[k - 1][j - speciale] != kInf) {
            dp[i][j] = min(dp[i][j], dp[k - 1][j - speciale] + cost);
          }
        }
      }
    }
    int ans = kInf;
    for (int i = 1; i <= n; i++) {
      ans = min(ans, dp[i][m]);
    }
    cout << ans << '\n';
  }

  return 0;
}
