#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

int main() {
    //ifstream cin("aranjare.in");
    //ofstream cout("aranjare.out");

    int n; cin >> n;
    vector<int> stk(n);
    for (auto& iter : stk) {
        cin >> iter;
        --iter;
    }

    vector<pair<int, int>> operations;
    for (int bit = 0; (1 << bit) < n; ++bit) {
        int num_set_bits = 0;
        for (int i = n - 1; i >= 0; --i) {
            const int stk_idx = (stk[i] >> bit & 1);
            operations.emplace_back(0, 1 + stk_idx);
            num_set_bits += stk_idx;
        }

        for (int i = 0; i < n - num_set_bits; ++i) {
            operations.emplace_back(1, 0);
        }
        for (int i = 0; i < num_set_bits; ++i) {
            operations.emplace_back(2, 0);
        }
        
        stable_partition(stk.begin(), stk.end(), [&](const int el) {
            return !(el >> bit & 1);
        });
    }

    cout << 2 << ' ' << operations.size() << '\n';
    for (auto&& operation : operations) {
        cout << operation.first << ' ' << operation.second << '\n';
    }
}