#include <bits/stdc++.h>
using namespace std;

vector<int> v[3] = {};
vector<pair<int, int>> sol;

void do_op(int x, int y){
    v[y].push_back(v[x].back());
    v[x].pop_back();
    sol.emplace_back(x, y); }

void sort_stack(int s, int depth, int a1, int a2, int mult = 1){
    if(depth == 1) return;
    for(int i = 0; i < depth; ++i)
        do_op(s, i < depth / 2 ? a1 : a2);
    sort_stack(a1, depth / 2, s, a2, -mult);
    sort_stack(a2, depth - depth / 2, s, a1, -mult);

    int i1 = depth / 2, i2 = depth - depth / 2;

    while(i1 || i2){
        if((i1 && i2 && v[a1].back() * mult < v[a2].back() * mult) || !i2){
            do_op(a1, s);
            --i1; }
        else{
            do_op(a2, s);
            --i2; } } }

int main(){
    //ifstream f("aranjamente.in");
    //ofstream g("aranjamente.out");
    auto& f = cin;
    auto& g = cout;
    int n;
    f >> n;
    for(int i = 1, x; i <= n; ++i){
        f >> x;
        v[0].push_back(x); }

    sort_stack(0, n, 1, 2);


    g << 2 << ' ' << sol.size() << endl;
    for(auto& x : sol) g << x.first << ' ' << x.second << endl;

    assert(v[0].size() == n);
    assert(is_sorted(begin(v[0]), end(v[0])));


    return 0; }
    
