#include <vector>
#include <iostream>
#include <fstream>
#include <numeric>
#include <algorithm>
using namespace std;

constexpr int maxn = 2000 + 100;
int v[maxn], sp[maxn], l[maxn], r[maxn], vals[maxn][maxn], d[maxn][maxn], nr_intervals = 0;

int get_sum(int x, int y){
    return sp[y] - sp[x-1]; }

int main(){
    int t;
    cin >> t;

    for(; t; t--) {
      nr_intervals = 0;
      for(auto& x : vals)
          for(auto& y : x)
              y = 1e9;
      for(auto& x : d)
          for(auto& y : x)
              y = 1e9;

      ifstream f("antivirus.in");
      ofstream g("antivirus.out");

      int n, k;
      f >> n >> k;
      for(int i = 1; i <= n; ++i) f >> v[i];
      partial_sum(v+1, v+n+1, sp+1);

      for(int i = 1; i <= n; ++i){
          if(v[i] != 0 && (i == 1 || v[i-1] == 0))
              l[nr_intervals] = i;
          if(v[i] != 0 && (i == n || v[i+1] == 0))
              r[nr_intervals++] = i;
          }

      for(int i = 0; i < nr_intervals; ++i) cout << l[i] << ' ' << r[i] << endl;;

      for(int i = 0; i < nr_intervals; ++i){
          vals[i][r[i] - l[i] + 1] = get_sum(l[i], r[i]);
          for(int j = l[i]; j <= r[i]; ++j)
              for(int k = j; k <= r[i]; ++k){
                  if(l[i] == 1 && j != 1) continue;
                  if(r[i] == n && k != n) continue;
                  vals[i][r[i] -k + j - l[i]] = min(
                      vals[i][r[i] - l[i] + j - k], get_sum(l[i], r[i]) - get_sum(j, k)); } }

      d[0][0] = 0;


      for(int i = 0; i < nr_intervals; ++i)
          for(int j = 0; j <= n; ++j)
              for(int val = 0; j + val <= n && /* rem this for O(n^3) */ val <= r[i] - l[i] + 1; ++val)
                  d[i+1][j+val] = min(d[i+1][j+val], d[i][j] + vals[i][val]);

      g << d[nr_intervals][k - count(v+1, v+n+1, 0)] << endl;
    }
    return 0; }
