#include<stdio.h>
#include<vector>
using namespace std;

#define NMAX 100005

int sol = 0, viz[NMAX], bc[NMAX], cuplaj[NMAX], n, t;
vector<int> tree[NMAX];

void clearAll() {
    for(int i = 1; i <= 2 * n; i++) {
        tree[i].clear();
    }
    sol = 0;

}

void backtracking(int poz) {
    if(poz == 2 * n) {
        int lim = tree[bc[poz]].size();
        for(int i = 0; i < lim; i++)
            if(tree[bc[poz]][i] == 1) {
                sol = 1;
                break;
            }
        return ;
    }

    if(poz&1) {
        if(viz[cuplaj[bc[poz]]]) {
            return ;
        }
        viz[cuplaj[bc[poz]]] = 1;
        bc[poz + 1] = cuplaj[bc[poz]];
        backtracking(poz + 1);
        viz[cuplaj[bc[poz]]] = 0;
        return ;
    }

    int lim = tree[bc[poz]].size(), vec;
    for(int i = 0; i < lim && !sol; i++) {
        if(!viz[vec = tree[bc[poz]][i]]) {
            bc[poz + 1] = vec;
            viz[vec] = 1;
            backtracking(poz + 1);
            viz[vec] = 0;
        }
    }
}

int main () {
    int a, b;

    freopen("dungeon.in","r",stdin);
    freopen("dungeon.out","w",stdout);

    scanf("%d",&t);
    for( ; t; t--) {
        scanf("%d",&n);
        for(int i = 1; i <= 2 * (n - 1); i++) {
            scanf("%d%d", &a, &b);
            tree[a].push_back(b);
            tree[b].push_back(a);
        }
        for(int i = 1; i <= n; i++) {
            scanf("%d%d",&a,&b);
            cuplaj[a] = b;
            cuplaj[b] = a;
        }

        if(n & 1) {
            printf("-1\n");
            clearAll();
            continue;
        }

        bc[1] = 1;
        viz[1] = 1;
        backtracking(1);

        if(!sol) {
            printf("-1\n");
        }
        else {
            for(int i = 1; i <= 2 * n; i++)
                printf("%d ", bc[i]);
            printf("\n");
        }
        clearAll();
    }

    return 0;
}
